<!--
  ~ iparapheur Web
  ~ Copyright (C) 2019-2025 Libriciel SCOP
  ~
  ~ This program is free software: you can redistribute it and/or modify
  ~ it under the terms of the GNU Affero General Public License as published by
  ~ the Free Software Foundation, either version 3 of the License, or
  ~ (at your option) any later version.
  ~
  ~ This program is distributed in the hope that it will be useful,
  ~ but WITHOUT ANY WARRANTY; without even the implied warranty of
  ~ MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  ~ GNU Affero General Public License for more details.
  ~
  ~ You should have received a copy of the GNU Affero General Public License
  ~ along with this program. If not, see <http://www.gnu.org/licenses/>.
  -->

<div class="modal-header">
  <h4
    class="modal-title"
    id="modal-basic-title"
    [innerText]="actionEnum.Chain | actionName">
  </h4>
  <button
    type="button"
    class="btn-close"
    [title]="commonMessages.CLOSE"
    (click)="activeModal.dismiss(commonMessages.ACTION_RESULT_CANCEL)">
  </button>
</div>

<div class="modal-body">
  <form class="ls-form row">

    <div class="col-4">

      <div class="form-group">
        <label
          for="typeSelector"
          [innerText]="commonMessages.TYPE">
        </label>
        <app-type-selector
          id="typeSelector"
          [mandatory]="true"
          [retrieveTypesFunction]="retrieveTypesFn"
          (typeChange)="onTypeSelectionChanged($event)">
        </app-type-selector>
      </div>

      <div class="form-group">
        <label
          for="subtypeSelector"
          [innerText]="commonMessages.SUBTYPE">
        </label>
        <app-subtype-selector
          id="subtypeSelector"
          [mandatory]="true"
          [retrieveSubtypesFunction]="retrieveSubtypesFn"
          [tenantId]="tenantId"
          [type]="selectedType"
          (subtypeChange)="onSubtypeSelectionChanged($event)">
        </app-subtype-selector>
      </div>

    </div>

    <div class="col-4">

      <div class="form-group">
        <label
          for="steps"
          [innerText]="commonMessages.WORKFLOW_STEPS_DEFINITION">
        </label>
        <app-workflow-steps
          id="steps"
          *ngIf="!!workflowDefinition"
          [tenantId]="tenantId"
          [workflowDefinition]="workflowDefinition"
          [deskId]="desk.id"
          [variableDesksIds]="variableDesksIds"
          [originDesk]="desk"
          [showStart]="true"
          [showEnd]="true">
        </app-workflow-steps>
      </div>

    </div>

    <div class="col-4">

      <div class="form-group">
        <label for="metadataList" [innerText]="commonMessages.METADATA_NAME_PLURAL"></label>
        <div *ngIf="selectedSubtype?.subtypeMetadataList?.length > 0">
          <div
            id="metadataList"
            *ngFor="let subtypeMetadata of selectedSubtype.subtypeMetadataList"
            class="form-group"
            [ngClass]="{ 'required': subtypeMetadata.mandatory }">

            <label [innerText]="subtypeMetadata.metadata.name"></label>
            <app-metadata-input
              [type]="subtypeMetadata.metadata.type"
              [restrictedValues]="subtypeMetadata.metadata.restrictedValues"
              [defaultValue]="getOrDefaultFn(folder.metadata, subtypeMetadata.metadataId, subtypeMetadata.defaultValue)"
              [editable]="true"
              [mandatory]="subtypeMetadata.mandatory"
              [(value)]="metadata[subtypeMetadata.metadata.key]"
              (valueChange)="metadataWasUpdated()">
            </app-metadata-input>
          </div>
        </div>
        <div
          *ngIf="selectedSubtype?.subtypeMetadataList?.length === 0"
          app-list-loader
          [data]="selectedSubtype?.subtypeMetadataList"
          [emptyMessage]="commonMessages.EMPTY_METADATA_LIST">
        </div>
      </div>

    </div>

    <div
      *ngIf="!isTypologyCompatible"
      class="ms-3 alert alert-danger"
      role="alert"
      [innerText]="messages.INCOMPATIBLE_FORMATS">
    </div>

  </form>
</div>

<div class="modal-footer">
  <button
    ls-button-cancel
    (click)="activeModal.close(commonMessages.ACTION_RESULT_CANCEL)">
  </button>
  <button
    ls-button
    (click)="perform()"
    [disabled]="!isFormValid()"
    [icon]="actionEnum.Chain | actionIcon"
    [text]="actionEnum.Chain | actionName: true"
    [processing]="isProcessing">
  </button>
</div>
